/*
 * This file is used for tests. Please do not use it as an example.
 */
#include <arpa/inet.h>

#include <glib.h>

#include "lql-con.h"
#include "lql-classifier.h"
#include "lql-classifier-u32.h"
#include "lql-classifier-fwmark.h"
#include "lql-u32match.h"

#define IP 8
#define QDISC 1
#define CLASS 2

int
main(int argc,
     char *argv[])
{
	LQLCon *con = NULL;
//	LQLClassifieru32 *u32 = NULL;
	LQLClassifierFwmark *fwmark = NULL;
	
	struct in_addr dst;

	inet_pton(AF_INET, "69.41.199.9", &dst);

	g_type_init();

	con = (LQLCon *) lql_con_new();

//	u32 = (LQLClassifieru32 *)lql_classifier_u32_new();
//	lql_classifier_set_priority(LQL_CLASSIFIER(u32), 5);
//	lql_classifier_set_ifIndex(LQL_CLASSIFIER(u32), 3);
//	lql_classifier_set_class(LQL_CLASSIFIER(u32), 65537);
//	lql_classifier_set_parent(LQL_CLASSIFIER(u32), 65536);
//	lql_classifier_set_id(LQL_CLASSIFIER(u32), 229376);
/* 	if (!lql_classifier_u32_add_match_ip_dst(u32, "69.41.196.163")) { */
/* 		g_printerr("Could not add match to u32 classifier.\n"); */
/* 		return(-1); */
/* 	} */

	fwmark = (LQLClassifierFwmark *)lql_classifier_fwmark_new();
	lql_classifier_set_priority(LQL_CLASSIFIER(fwmark), 5);
	lql_classifier_set_ifIndex(LQL_CLASSIFIER(fwmark), 4);
	lql_classifier_set_classHandle(LQL_CLASSIFIER(fwmark), 65537);
	lql_classifier_set_parentHandle(LQL_CLASSIFIER(fwmark), 65536);
	lql_classifier_set_id(LQL_CLASSIFIER(fwmark), 229376);
	if (!lql_classifier_add(LQL_CLASSIFIER(fwmark), con)) {
		g_printerr("Could not add classifier.\n");
		return(-1);
	}

	g_object_unref(fwmark);
	g_object_unref(con);

	return(0);
}
