/*
 * Add a HTB QDisc to interface index 3 with a default class of 1.
 */
#include <glib.h>

#include "lql-con.h"
#include "lql-qdisc.h"
#include "lql-qdisc-htb.h"

int
main(int argc,
     char *artv[])
{
	LQLCon *con = NULL;
	LQLQDiscHTB *qdisc = NULL;

	g_type_init();

	con = (LQLCon *)lql_con_new();

	qdisc = (LQLQDiscHTB *)lql_qdisc_htb_new();
	lql_qdisc_set_parent(LQL_QDISC(qdisc), NULL);
	lql_qdisc_set_id(LQL_QDISC(qdisc), 1);
	lql_qdisc_htb_set_defaultClass(LQL_QDISC_HTB(qdisc), 1);
	lql_element_set_ifIndex(LQL_ELEMENT(qdisc), 3);

	lql_qdisc_add(LQL_QDISC(qdisc), con);

	g_object_unref(qdisc);
	g_object_unref(con);

	return(0);
}
