/*
 * Get a list of the network interfaces on the system and their parameters.
 */
#include <glib.h>

#include "lql-con.h"
#include "lql-interface.h"

int
main(int argc,
     char *argv[])
{
	LQLCon *con = NULL;
	LQLInterface *ifindex = NULL;
	GList *list = NULL, *tmp = NULL;

	g_type_init();

	con = (LQLCon *) lql_con_new();
	
	list = lql_con_get_interfaces(con);

	g_print("Found %i interfaces.\n", g_list_length(list));

	tmp = list;
	while (tmp != NULL) {
		ifindex = (LQLInterface *)tmp->data;

		g_print("-----------------------------\n");
		g_print("Name: %s\n", lql_interface_get_name(ifindex));
		g_print("Index: %i\n", lql_interface_get_ifIndex(ifindex));
		g_print("MTU: %i\n", lql_interface_get_mtu(ifindex));
		
		tmp = tmp->next;
	}

	g_print("-- Getting interface #2 --\n");
	ifindex = (LQLInterface *)lql_con_get_interface(con, 2);
	g_print("Name: %s\n", lql_interface_get_name(ifindex));
	g_print("Index: %i\n", lql_interface_get_ifIndex(ifindex));
	g_print("MTU: %i\n", lql_interface_get_mtu(ifindex));

	return(0);
}
