/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_CLASSIFIER_FWMARK_H_
#define _LQL_CLASSIFIER_FWMARK_H_

#include <glib-object.h>
#include "nl.h"
#include "lql-classifier.h"

#define LQL_TYPE_CLASSIFIER_FWMARK (lql_classifier_fwmark_get_type ())
#define LQL_CLASSIFIER_FWMARK(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), LQL_TYPE_CLASSIFIER_FWMARK, LQLClassifierFwmark))
#define LQL_CLASSIFIER_FWMARK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), LQL_TYPE_CLASSIFIER_FWMARK, LQLClassifierFwmarkClass))
#define LQL_IS_CLASSIFIER_FWMARK(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), LQL_TYPE_CLASSIFIER_FWMARK))
#define LQL_IS_CLASSIFIER_FWMARK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), LQL_TYPE_CLASSIFIER_FWMARK))
#define LQL_CLASSIFIER_FWMARK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), LQL_TYPE_CLASSIFIER_FWMARK, LQLClassifierFwmarkClass))

typedef struct _LQLClassifierFwmark LQLClassifierFwmark;
typedef struct _LQLClassifierFwmarkClass LQLClassifierFwmarkClass;
typedef struct _LQLClassifierFwmarkPrivate LQLClassifierFwmarkPrivate;

struct _LQLClassifierFwmark {
	LQLClassifier parent;

	/* Instance members */
        LQLClassifierFwmarkPrivate *private;
};

struct _LQLClassifierFwmarkClass {
	LQLClassifierClass parent;

	/* Class members */
};

/* used by LQL_TYPE_CLASSIFIER_FWMARK */
GType lql_classifier_fwmark_get_type (void);

/* Non-virtual API. */
LQLClassifierFwmark* lql_classifier_fwmark_new(void);
guint32 lql_classifier_fwmark_get_mark(LQLClassifierFwmark *self);
gboolean lql_classifier_fwmark_set_mark(LQLClassifierFwmark *self, guint32 mark);

/* Virtual API. */

#endif /* _LQL_CLASSIFIER_FWMARK_H_ */
