/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_CLASSIFIER_U32_H_
#define _LQL_CLASSIFIER_U32_H_

#include <glib-object.h>
#include "nl.h"
#include "lql-classifier.h"
#include "lql-u32match.h"

#define LQL_TYPE_CLASSIFIER_U32 (lql_classifier_u32_get_type ())
#define LQL_CLASSIFIER_U32(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), LQL_TYPE_CLASSIFIER_U32, LQLClassifierU32))
#define LQL_CLASSIFIER_U32_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), LQL_TYPE_CLASSIFIER_U32, LQLClassifierU32Class))
#define LQL_IS_CLASSIFIER_U32(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), LQL_TYPE_CLASSIFIER_U32))
#define LQL_IS_CLASSIFIER_U32_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), LQL_TYPE_CLASSIFIER_U32))
#define LQL_CLASSIFIER_U32_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), LQL_TYPE_CLASSIFIER_U32, LQLClassifierU32Class))

typedef struct _LQLClassifierU32 LQLClassifierU32;
typedef struct _LQLClassifierU32Class LQLClassifierU32Class;
typedef struct _LQLClassifierU32Private LQLClassifierU32Private;

struct _LQLClassifierU32 {
	LQLClassifier parent;

	/* Instance members */
        LQLClassifierU32Private *private;
};

struct _LQLClassifierU32Class {
	LQLClassifierClass parent;

	/* Class members */
};

/* used by LQL_TYPE_CLASSIFIER_U32 */
GType lql_classifier_u32_get_type (void);

/* Non-virtual API. */
LQLClassifierU32* lql_classifier_u32_new(void);
guint32 lql_classifier_u32_get_hash(LQLClassifierU32 *self);
gboolean lql_classifier_u32_set_hash(LQLClassifierU32 *self, guint32 hash);
guint32 lql_classifier_u32_get_link(LQLClassifierU32 *self);
gboolean lql_classifier_u32_set_link(LQLClassifierU32 *self, guint32 link);
guint32 lql_classifier_u32_get_divisor(LQLClassifierU32 *self);
gboolean lql_classifier_u32_set_divisor(LQLClassifierU32 *self, guint32 divisor);
guint32 lql_classifier_u32_get_hashMask(LQLClassifierU32 *self);
gboolean lql_classifier_u32_set_hashMask(LQLClassifierU32 *self, guint32 hashMask);
guint32 lql_classifier_u32_get_hashOffset(LQLClassifierU32 *self);
gboolean lql_classifier_u32_set_hashOffset(LQLClassifierU32 *self, guint32 hashOffset);

guint16 lql_classifier_u32_get_handle(LQLClassifierU32 *self);
gboolean lql_classifier_u32_set_handle(LQLClassifierU32 *self, guint16 handle);
guint16 lql_classifier_u32_get_hashHandle(LQLClassifierU32 *self);
gboolean lql_classifier_u32_set_hashHandle(LQLClassifierU32 *self, guint16 hashHandle);
guint16 lql_classifier_u32_get_hashNode(LQLClassifierU32 *self);
gboolean lql_classifier_u32_set_hashNode(LQLClassifierU32 *self, guint16 hashNode);

gboolean lql_classifier_u32_add_match(LQLClassifierU32 *self, LQLU32Match *sel);
gboolean lql_classifier_u32_add_match_ip_dst(LQLClassifierU32 *self, const gchar *ip);
LQLU32Match* lql_classifier_u32_get_match(LQLClassifierU32 *self, int position);
int lql_classifier_u32_get_match_len(LQLClassifierU32 *self);

/* Virtual API. */

#endif /* _LQL_CLASSIFIER_U32_H_ */
