/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_CON_H_
#define _LQL_CON_H_

#include <glib-object.h>
#include "nl.h"

#define LQL_TYPE_CON (lql_con_get_type ())
#define LQL_CON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LQL_TYPE_CON, LQLCon))
#define LQL_CON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LQL_TYPE_CON, LQLConClass))
#define LQL_IS_CON(obj) (G_TYPE_CHECK_TYPE ((obj), LQL_TYPE_CON))
#define LQL_IS_CON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LQL_TYPE_CON))
#define LQL_CON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LQL_TYPE_CON, LQLConClass))

typedef struct _LQLCon LQLCon;
typedef struct _LQLConClass LQLConClass;
typedef struct _LQLConPrivate LQLConPrivate;

struct _LQLCon {
	GObject parent;

	/* Instance members */
        LQLConPrivate *private;
};

struct _LQLConClass {
	GObjectClass parent;

	/* Class members */
};

/* used by LQL_TYPE_CON */
GType lql_con_get_type (void);

/* Non-virtual API. */
LQLCon* lql_con_new(void);
int lql_con_get_inc_sequence(LQLCon *self);
double lql_con_get_tickInUsec(LQLCon *self);
double lql_con_get_hz(LQLCon *self);
NLCon* lql_con_get_nlcon(LQLCon *self);
GObject* lql_con_get_interface(LQLCon *self, int index);
GList* lql_con_get_interfaces(LQLCon *self);
GList* lql_con_get_qdiscs(LQLCon *self, int index);
GList* lql_con_get_classes(LQLCon *self, int index);
GList* lql_con_get_classifiers(LQLCon *self, int index);
int lql_con_get_cell_log(LQLCon *self, int size);
unsigned lql_con_calc_xmit_time(LQLCon *self, guint32 bps, guint32 size);
gboolean lql_con_calc_rate_table(LQLCon *self, guint32 bps, guint32 *rtab, guint32 mtu, guint32  mpu);

/* Virtual API. */

#endif /* _LQL_CON_H_ */
