/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_ELEMENT_H_
#define _LQL_ELEMENT_H_

#include <glib-object.h>

#include "lql-interface.h"

#define LQL_TYPE_ELEMENT (lql_element_get_type ())
#define LQL_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), LQL_TYPE_ELEMENT, LQLElement))
#define LQL_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), LQL_TYPE_ELEMENT, LQLElementClass))
#define LQL_IS_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), LQL_TYPE_ELEMENT))
#define LQL_IS_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), LQL_TYPE_ELEMENT))
#define LQL_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), LQL_TYPE_ELEMENT, LQLElementClass))

typedef struct _LQLElement LQLElement;
typedef struct _LQLElementClass LQLElementClass;
typedef struct _LQLElementPrivate LQLElementPrivate;

struct _LQLElement {
	GObject parent;

	/* Instance members */
        LQLElementPrivate *private;
};

struct _LQLElementClass {
	GObjectClass parent;

	/* Class members */
};

/* used by LQL_TYPE_ELEMENT */
GType lql_element_get_type (void);

/* Non-virtual API. */
LQLElement* lql_element_new(void);

gboolean lql_element_set_interface(LQLElement *self, LQLInterface *interface);
int lql_element_get_ifIndex(LQLElement *self);
gboolean lql_element_set_ifIndex(LQLElement *self, int ifIndex);

guint32 lql_element_get_parentHandle(LQLElement *self);
gboolean lql_element_set_parentHandle(LQLElement *self, guint32 parentHandle);

guint32 lql_element_get_handle(LQLElement *self);
gboolean lql_element_set_handle(LQLElement *self, guint32 handle);

/* Virtual API. */

#endif /* _LQL_ELEMENT_H_ */
