/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_QDISC_PRIOMAP_H_
#define _LQL_QDISC_PRIOMAP_H_

#include <glib-object.h>
#include "nl.h"
#include "lql-qdisc.h"

#define LQL_TYPE_QDISC_PRIOMAP (lql_qdisc_priomap_get_type ())
#define LQL_QDISC_PRIOMAP(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), LQL_TYPE_QDISC_PRIOMAP, LQLQDiscPriomap))
#define LQL_QDISC_PRIOMAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), LQL_TYPE_QDISC_PRIOMAP, LQLQDiscPriomapClass))
#define LQL_IS_QDISC_PRIOMAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), LQL_TYPE_QDISC_PRIOMAP))
#define LQL_IS_QDISC_PRIOMAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), LQL_TYPE_QDISC_PRIOMAP))
#define LQL_QDISC_PRIOMAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), LQL_TYPE_QDISC_PRIOMAP, LQLQDiscPriomapClass))

typedef struct _LQLQDiscPriomap LQLQDiscPriomap;
typedef struct _LQLQDiscPriomapClass LQLQDiscPriomapClass;
typedef struct _LQLQDiscPriomapPrivate LQLQDiscPriomapPrivate;

struct _LQLQDiscPriomap {
	LQLQDisc parent;

	/* Instance members */
        LQLQDiscPriomapPrivate *private;
};

struct _LQLQDiscPriomapClass {
	LQLQDiscClass parent;

	/* Class members */
};

/* used by LQL_TYPE_QDISC_PRIOMAP */
GType lql_qdisc_priomap_get_type (void);

/* Non-virtual API. */
LQLQDiscPriomap* lql_qdisc_priomap_new(void);
int lql_qdisc_priomap_get_bands(LQLQDiscPriomap *self);
gboolean lql_qdisc_priomap_set_bands(LQLQDiscPriomap *self, int bands);
gboolean lql_qdisc_priomap_set_prio(LQLQDiscPriomap *self, int index, unsigned char value);
unsigned char lql_qdisc_priomap_get_prio(LQLQDiscPriomap *self, int index);

/* Virtual API. */

#endif /* _LQL_QDISC_PRIOMAP_H_ */
