/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_HELPER_QDISC_H_
#define _LQL_HELPER_QDISC_H_

#include "lql-con.h"
#include "lql-qdisc.h"

gboolean lql_con_helper_init(LQLCon *con);
GList* lql_con_helper_get_interfaces(LQLCon *con);
GObject* lql_con_helper_get_interface(LQLCon *con, int index);
GList* lql_con_helper_get_qdiscs(LQLCon *con, int index);
GList* lql_con_helper_get_classes(LQLCon *con, int index);
GList* lql_con_helper_get_classifiers(LQLCon *con, int index);
int lql_con_helper_get_cell_log(int size);
gboolean lql_con_helper_calc_rate_table(LQLCon *con, unsigned bps, __u32 *rtab, unsigned mtu, unsigned mpu);
unsigned lql_con_helper_calc_xmit_time(LQLCon *con, unsigned bps, unsigned size);

#endif
